module(..., package.seeall)
local s = require'scheme'
local usb = require'nsgusbconf'

local function asIs(...)
  return ...
end

local ms6Sensors = setmetatable(
  {
    TEMP = {1, asIs},
    HUMI = {2, asIs},
    LUMI = {3, asIs},
    PYRO = {4, asIs},
    MAGN = {5, asIs},
    ACCL = {6, asIs},
  },
  {__index = function() return {0, asIs} end }
)


local function ms6show(dev)
  os.execute("stty -F %s raw -echo" % dev)
  local ms, err = io.open(dev, 'r')
  if ms then
    local res = {'','','','','',''}
    for i = 1, 6 do
      local str = ms:read()
      print(i, '%q'%str)
      local sens, val = str:match(":NFC;([%w_]*);(.*)\r") 

      if sens then
        res[ms6Sensors[sens][1]] = sens..': '..ms6Sensors[sens][2](val)
      end
    end
    ms:close()
    return '\n'..table.concat(res, '\n')..'\n'
  else
    return err
  end
end

ms6Scheme = s.newScheme{
  show = s.newScheme{
    _H = "ms6Show",
    _X = function(path)
      usb.probeUSBDeviceScheme(nil, s.clonePath(path, -1))
      return ms6show(usb.port2tty[path[#path - 1]])
    end,
    _R = 'user',
  },
}
